//##################################################################################################
//
//  Ceetron Export
//  VTFxExample
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################


#pragma once

#include "CeeVTFx/ElementBlock.h"


// Part 1
// -----------------------------------------------------------------------------
// Nodes for part 1
const float NODES_PART_1[] =
{
    0.0f, 0.0f, 0.0f,
    1.0f, 0.0f, 0.0f,
    1.0f, 1.0f, 0.0f,
    0.0f, 1.0f, 0.0f,
    0.0f, 0.0f, 1.0f,
    1.0f, 0.0f, 1.0f,
    1.0f, 1.0f, 1.0f,
    0.0f, 1.0f, 1.0f,
    0.0f, 0.0f, 2.0f,
    1.0f, 0.0f, 2.0f,
    1.0f, 1.0f, 2.0f,
    0.0f, 1.0f, 2.0f
};

const int NODES_PART_1_IDS[] =
{
    1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
};


// Elements for part 1
const int CONNECTS_PART_1[] =
{
    0, 1, 2, 3, 4, 5, 6, 7,
    4, 5, 6, 7, 8, 9, 10, 11
};
const cee::vtfx::ElementBlock::ElementType elementTypePart1 = cee::vtfx::ElementBlock::HEXAHEDRONS;

const int ELEMENTS_PART_1_IDS[] =
{
    1, 2
};


// Part 2
// -----------------------------------------------------------------------------
// Nodes for part 2
const float NODES_PART_2[] =
{
    2.0f, 0.0f, 0.0f,
    3.0f, 0.0f, 0.0f,
    3.0f, 1.0f, 0.0f,
    2.0f, 1.0f, 0.0f,
    4.0f, 0.0f, 0.0f,
    4.0f, 1.0f, 0.0f
};

const int NODES_PART_2_IDS[] =
{
    101, 102, 103, 104, 105, 106
};


// Elements for part 2
const int CONNECTS_PART_2[] =
{
    0, 1, 2, 3,
    1, 4, 5, 2
};
const cee::vtfx::ElementBlock::ElementType elementTypePart2 = cee::vtfx::ElementBlock::QUADS;

const int ELEMENTS_PART_2_IDS[] = 
{
    3, 4
};


// Geometry definition
// -----------------------------------------------------------------------------
const int ELEMENT_PARTS[] =
{
    1, 2
};


// Time step 1 - Scalar Result 1
// -----------------------------------------------------------------------------
const float RESULT1_P1_S1[] =
{
    0.0,
    0.5,
    1.5,
    2.0,
    3.0,
    4.0,
    5.0,
    6.0,
    6.5,
    7.0,
    7.5,
    8.0
};
const float RESULT1_P2_S1[] =
{
    1.0,
    5.0,
    3.0,
    2.0,
    5.0,
    1.0
};



// Time step 2 - Scalar Result 1
// -----------------------------------------------------------------------------
const float RESULT1_P1_S2[] =
{
    8.1f,
    9.6f,
    5.8f,
    3.5f,
    7.4f,
    9.7f,
    2.7f,
    6.5f,
    3.2f,
    4.6f,
    3.7f,
    2.2f
};
const float RESULT1_P2_S2[] =
{
    1.5f,
    2.1f,
    4.5f,
    5.5f,
    2.1f,
    1.1f
};



// Time step 1 - Vector Result 1
// -----------------------------------------------------------------------------
const float RESULT2_P1_S1[] =
{
    0.0, 0.0, 0.0,
    1.0, 0.0, 0.0,
    1.0, 1.0, 0.0,
    0.0, 1.0, 0.0,
    0.0, 0.0, 1.0,
    1.0, 0.0, 1.0,
    1.0, 1.0, 1.0,
    0.0, 1.0, 1.0,
    0.0, 0.0, 2.0,
    1.0, 0.0, 2.0,
    1.0, 1.0, 2.0,
    0.0, 1.0, 2.0
};
const float RESULT2_P2_S1[] =
{
    2.0, 0.0, 0.0,
    3.0, 0.0, 0.0,
    3.0, 1.0, 0.0,
    2.0, 1.0, 0.0,
    4.0, 0.0, 0.0,
    4.0, 1.0, 0.0,
};


// Time step 2 - Vector Result 2
// -----------------------------------------------------------------------------
const float RESULT2_P1_S2[] =
{
    1.0, 8.0, 1.0,
    3.0, 2.0, 5.0,
    5.0, 8.0, 7.0,
    3.0, 4.0, 9.0,
    5.0, 2.0, 3.0,
    7.0, 1.0, 2.0,
    2.0, 7.0, 1.0,
    5.0, 6.0, 5.0,
    7.0, 5.0, 8.0,
    6.0, 4.0, 0.0,
    4.0, 2.0, 0.0,
    1.0, 2.0, 2.0
};
const float RESULT2_P2_S2[] =
{
    1.0, 4.0, 2.0,
    6.0, 8.0, 5.0,
    8.0, 7.0, 7.0,
    3.0, 3.0, 8.0,
    7.0, 5.0, 2.0,
    3.0, 3.0, 1.0,
};


// Time step 1 - Dispacement Result 1
// -----------------------------------------------------------------------------
const float RESULT3_P1_S1[] =
{
    0.0f, 0.0f, 0.0f,
    1.0f, 0.0f, 0.0f,
    1.0f, 1.0f, 0.0f,
    0.0f, 1.0f, 0.0f,
    0.0f, 0.0f, 1.0f,
    1.0f, 0.0f, 1.0f,
    1.0f, 1.0f, 1.0f,
    0.0f, 1.0f, 1.0f,
    0.0f, 0.0f, 2.0f,
    1.0f, 0.0f, 2.0f,
    1.0f, 1.0f, 2.0f,
    0.0f, 1.0f, 2.0f
};
const float RESULT3_P2_S1[] =
{
    2.0, 0.0, 0.0,
    3.0, 0.0, 0.0,
    3.0, 1.0, 0.0,
    2.0, 1.0, 0.0,
    4.0, 0.0, 0.0,
    4.0, 1.0, 0.0,
};

// Time step 2 - Displacement Result 1
// -----------------------------------------------------------------------------
const float RESULT3_P1_S2[] =
{
    0.0f, 0.0f, 0.0f,
    1.5f, 0.0f, 0.0f,
    1.5f, 1.0f, 0.0f,
    0.0f, 1.0f, 0.0f,
    0.0f, 0.0f, 1.0f,
    1.5f, 0.0f, 1.0f,
    1.5f, 1.0f, 1.0f,
    0.0f, 1.0f, 1.0f,
    0.0f, 0.0f, 2.0f,
    1.5f, 0.0f, 2.0f,
    1.5f, 1.0f, 2.0f,
    0.0f, 1.0f, 2.0f
};
const float RESULT3_P2_S2[] =
{
    2.0, 0.0, 0.0,
    3.0, 0.0, 0.0,
    3.0, 1.0, 0.0,
    2.0, 1.0, 0.0,
    4.0, 0.0, 0.5,
    4.0, 1.0, 0.5,
};

