
TEMPLATE = app

QT += network 

INCLUDEPATH += . 
INCLUDEPATH += ../../../include
INCLUDEPATH += ../../../PlatformIntegration/Qt

CONFIG(debug, debug|release)   {
	win32 {
		LIBS += CeeCored.lib
		LIBS += CeeVTFxd.lib
	}
	unix {
		LIBS += -lCeeCored
		LIBS += -lCeeVTFxd
	}
}
CONFIG(release, debug|release) {
	win32 {
		LIBS += CeeCore.lib
		LIBS += CeeVTFx.lib
	}
	unix {
		LIBS += -lCeeCore
		LIBS += -lCeeVTFx
	}
}

SOURCES += QSCMain.cpp 
HEADERS += QSCCloudTracker.h 
HEADERS += ../../../PlatformIntegration/Qt/ceeqtUtilsCore.h


# Set path to where the component libraries reside
win32 {
    CONFIG(debug, debug|release)   { CEE_LIBDIR = $${PWD}/../../../lib/Debug   }
    CONFIG(release, debug|release) { CEE_LIBDIR = $${PWD}/../../../lib/Release }
    CEE_LIBDIR ~= s,/,\\,g
}
unix {
    CONFIG(debug, debug|release)   { CEE_LIBDIR = $${PWD}/../../../lib/Debug   }
    CONFIG(release, debug|release) { CEE_LIBDIR = $${PWD}/../../../lib/Release }
}
  

# Add to the directory to QMAKE_LIBDIR
message("CEE_LIBDIR = $${CEE_LIBDIR}")
QMAKE_LIBDIR += $$CEE_LIBDIR
  
# On windows/VS, copy the component DLLs to the output directory
win32 {
    CONFIG(debug, debug|release)   { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" debug" }
    CONFIG(release, debug|release) { QMAKE_POST_LINK = "copy \"$${CEE_LIBDIR}\\*.dll\" release" }
}

# On Linux either us rpath relative to executable and then copy .so files...
#unix:QMAKE_LFLAGS += "-Wl,-rpath,\'\$$ORIGIN/.\'"
#unix:QMAKE_POST_LINK = "cp $${CEE_LIBDIR}/libCee*.so ."

# ...or insert full rpath (seems to work best with QtCreator)
unix:QMAKE_RPATHDIR += $$CEE_LIBDIR
