//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Base.h"


// The default configuration is for consuming CDC as a dynamic library (DLL).
// To build DLL version of CDC, CEE_XXXX_BUILD_DLL_EXPORT must be defined and CEE_STATIC_LIBS must NOT be defined.
// To build or use CDC as static libraries, make sure CEE_STATIC_LIBS is defined.
#ifdef CEE_STATIC_LIBS
    #define CEE_VTFX_EXPORT
#else
    #if defined(WIN32)
        #ifdef CEE_VTFX_BUILD_DLL_VTFX
            #define CEE_VTFX_EXPORT __declspec(dllexport)
        #else
            #define CEE_VTFX_EXPORT __declspec(dllimport)
        #endif
    #elif defined(__GNUC__)
        #ifdef CEE_VTFX_BUILD_DLL_VTFX
            #define CEE_VTFX_EXPORT __attribute__ ((visibility ("default")))
        #else
            #define CEE_VTFX_EXPORT
        #endif
    #else
        #define CEE_VTFX_EXPORT
    #endif
#endif

