//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"

#include "CeeCore/RefCountedObject.h"

class VTFxBlock;

namespace cee {
namespace vtfx {

//==================================================================================================
//
// 
//
//==================================================================================================
class CEE_VTFX_EXPORT Block : public RefCountedObject
{
public:

    // Block types
    // -----------------------------------------------------------------------------
    enum BlockType { 
        NODES, 
        ELEMENTS,
        GEOMETRY,
        GEOMETRYINFO,
        RESULT,
        RESULTVALUES,
        TRANSFORMATIONRESULT,
        TRANSFORMATIONRESULTVALUES,
        STATEINFO,
        SET,
        ILLEGAL
    };


public:
    Block(int blockId);
    virtual ~Block();

    int                 blockId() const;
    BlockType           blockType() const;

    virtual bool        checkValidity() const;

protected:
    virtual VTFxBlock*  internal_vtfxBlock() const = 0;

private:
    friend class Database;

    CEE_PRIVATE_IMPL(Block);
    CEE_DISALLOW_COPY_AND_ASSIGN(Block);
};

}
}
