//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"
#include "CeeVTFx/Block.h"

#include <vector>

class VTFxGeometryBlock;

namespace cee {
namespace vtfx {

//=================================================================================================================================
//
// 
//
//=================================================================================================================================
class CEE_VTFX_EXPORT GeometryBlock : public Block
{
public:
    GeometryBlock(size_t geometryCountPerState);
    virtual ~GeometryBlock();

    size_t              geometryCountPerState() const;
    size_t              stateCount() const;
    size_t              partCount(size_t geometryIndex, size_t stateIndex) const;
    std::vector<int>    elementBlockIds(size_t geometryIndex, size_t stateIndex) const;

    bool                setElementBlocks(size_t geometryIndex, const std::vector<int>& elementBlockIds, const std::vector<int>& partIds);
    bool                addElementBlock(size_t geometryIndex, int elementBlockId, int partId);

    bool                setElementBlocksForState(size_t geometryIndex, const std::vector<int>& elementBlockIds, int stateId, const std::vector<int>& partIds);
    bool                addElementBlockForState(size_t geometryIndex, int elementBlockId, int stateId, int partId);

    bool                checkValidity() const;

private:
    GeometryBlock(VTFxGeometryBlock* block, int blockId);

    VTFxBlock*  internal_vtfxBlock() const;

private:
    friend class DatabasePrivate;

    CEE_PRIVATE_IMPL(GeometryBlock);
    CEE_DISALLOW_COPY_AND_ASSIGN(GeometryBlock);
};

}
}
