//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"
#include "CeeVTFx/Block.h"
#include "CeeCore/Str.h"

class VTFxGeometryInfoBlock;

namespace cee {
namespace vtfx {

//=================================================================================================================================
//
//
//
//=================================================================================================================================
class CEE_VTFX_EXPORT GeometryInfoBlock : public Block
{
public:
    GeometryInfoBlock(size_t geometryCountPerState);
    virtual ~GeometryInfoBlock();

    size_t      geometryCountPerState() const;

    size_t      partCount(size_t geometryIndex) const;
    int         partId(size_t geometryIndex, size_t partIndex) const;
    Str         partName(size_t geometryIndex, size_t partIndex) const;
    void        addPartInfo(size_t geometryIndex, int id, const Str& name);

private:
    GeometryInfoBlock(VTFxGeometryInfoBlock* block, int blockId);

    VTFxBlock*  internal_vtfxBlock() const;

private:
    friend class DatabasePrivate;

    CEE_PRIVATE_IMPL(GeometryInfoBlock);
    CEE_DISALLOW_COPY_AND_ASSIGN(GeometryInfoBlock);

};

}
}
