//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"
#include "CeeVTFx/Block.h"
#include "CeeCore/Str.h"

class VTFxTransformationResultsBlock;

namespace cee {
namespace vtfx {

//=================================================================================================================================
//
//
//
//=================================================================================================================================
class CEE_VTFX_EXPORT TransformationResultBlock : public Block
{
public:
    TransformationResultBlock(int blockId);
    ~TransformationResultBlock();

    Str                 name() const;
    void                setName(const Str& resultName);
    int                 resultId() const;
    void                setResultId(int resultId);

    std::vector<int>    transformationResultValuesBlocks(size_t stateIndex) const;
    int                 transformationResultValuesBlockCount(size_t stateIndex) const;
    bool                addTransformationResultValuesBlock(int transformationResultValuesBlockId, int stateId = 1);
    bool                setTransformationResultValuesBlocks(const std::vector<int>& transformationResultValuesBlockIds, int stateId = 1);

    size_t              stateCount() const;
    size_t              stateIndex(int stateId) const;
    int                 stateId(size_t stateIndex) const;

    bool                checkValidity() const;

private:
    TransformationResultBlock(VTFxTransformationResultsBlock* block, int blockId);

    VTFxBlock*          internal_vtfxBlock() const;

private:
    friend class DatabasePrivate;

    CEE_PRIVATE_IMPL(TransformationResultBlock);
    CEE_DISALLOW_COPY_AND_ASSIGN(TransformationResultBlock);
};

}
}
