//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2015, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeCore/Mat4d.h"
#include "CeeVTFx/Base.h"
#include "CeeVTFx/Block.h"

#include <vector>

class VTFxTransformationResultValuesBlock;

namespace cee {
namespace vtfx {

//=================================================================================================================================
//
//
//
//=================================================================================================================================
class CEE_VTFX_EXPORT TransformationResultValuesBlock : public Block
{
public:
    TransformationResultValuesBlock(int blockId);
    ~TransformationResultValuesBlock();

    int                 mapToBlockId(BlockType* blockType) const;
    bool                setMapToBlockId(int blockId, Block::BlockType blockType);

    Mat4d               matrix() const;
    void                setMatrix(const Mat4d& matrix);

    bool                checkValidity() const;

private:
    TransformationResultValuesBlock(VTFxTransformationResultValuesBlock* block, int blockId);
    VTFxBlock*          internal_vtfxBlock() const;

private:
    friend class DatabasePrivate;

    CEE_PRIVATE_IMPL(TransformationResultValuesBlock);
    CEE_DISALLOW_COPY_AND_ASSIGN(TransformationResultValuesBlock);
};

}
}
