//##################################################################################################
//
//  Ceetron Export
//  Component: VTFx
//  
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2011, Ceetron AS
//  This is UNPUBLISHED PROPRIETARY SOURCE CODE of Ceetron AS. The contents of this file may 
//  not be disclosed to third parties, copied or duplicated in any form, in whole or in part,
//  without the prior written permission of Ceetron AS.
//##################################################################################################

#pragma once

#include "CeeVTFx/Base.h"

#include "CeeCore/Str.h"

namespace cee {

class Instance;

namespace vtfx {


//==================================================================================================
//
// Static class for VTFx component
//
//==================================================================================================
class CEE_VTFX_EXPORT VTFxComponent
{
public:
    static bool             isInitialized();
    static bool             initialize(Instance* instance);

    static bool             isEvaluationVersion();
    static int              licenseNumber();

    static unsigned int     version();
    static Str              versionString();

private:
    CEE_DISALLOW_COPY_AND_ASSIGN(VTFxComponent);
};


}  // namespace ug
}  // namespace cee
